
package require tkwav 1.0


set id 0
proc LoadSound {f} {
    global id
    set name "sound[incr id]"
    set row [lindex [grid size .sounds] 1]
    
    tkwav::load $name $f
    
    label  .sounds.file_$name -text "$f:" -justify left
    button .sounds.play_$name -text "Play" -command [list $name play]
    button .sounds.loop_$name -text "Loop" -command [list $name loop]
    button .sounds.stop_$name -text "Stop" -command [list $name stop]
    button .sounds.kill_$name -text "Destroy" -command \
            [list DestroySound $name]
    
    grid configure .sounds.file_$name \
            -row $row -column 0 -sticky ew -padx 2 -pady 2
    grid configure .sounds.play_$name \
            -row $row -column 1 -sticky ew -padx 2 -pady 2
    grid configure .sounds.loop_$name \
            -row $row -column 2 -sticky ew -padx 2 -pady 2
    grid configure .sounds.stop_$name \
            -row $row -column 3 -sticky ew -padx 2 -pady 2
    grid configure .sounds.kill_$name \
            -row $row -column 4 -sticky ew -padx 2 -pady 2
}

proc DestroySound {name} {
    tkwav::destroy $name
    destroy .sounds.file_$name .sounds.play_$name .sounds.loop_$name \
            .sounds.stop_$name .sounds.kill_$name
}


proc LoadSoundDlg {} {
    set snd [tk_getOpenFile \
            -title "Open Sound File" \
            -filetypes {{"WAV Files" {.wav}}} \
            -defaultextension .wav ]
    
    if {$snd != ""} { LoadSound $snd }
}

frame .sounds -relief raised -bd 1
grid columnconfigure .sounds 1 -weight 1
grid columnconfigure .sounds 2 -weight 1
grid columnconfigure .sounds 3 -weight 1
grid columnconfigure .sounds 4 -weight 1
grid configure .sounds -row 0 -column 0 -sticky new

frame .btns
button .open -text "Open..." -command LoadSoundDlg
button .exit -text "Exit" -command exit
pack .open .exit -in .btns -side left -padx 4 -pady 4
grid configure .btns -row 1 -column 0 -sticky swe

grid rowconfigure . 0 -weight 1
grid columnconfigure . 0 -weight 1
